git-clone.shon commit Merge branch 'maint' (27e4dd8)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, Linus Torvalds
   4# Copyright (c) 2005, Junio C Hamano
   5# 
   6# Clone a repository into a different directory that does not yet exist.
   7
   8# See git-sh-setup why.
   9unset CDPATH
  10
  11die() {
  12        echo >&2 "$@"
  13        exit 1
  14}
  15
  16usage() {
  17        die "Usage: $0 [--template=<template_directory>] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [-n] <repo> [<dir>]"
  18}
  19
  20get_repo_base() {
  21        (cd "$1" && (cd .git ; pwd)) 2> /dev/null
  22}
  23
  24if [ -n "$GIT_SSL_NO_VERIFY" ]; then
  25    curl_extra_args="-k"
  26fi
  27
  28http_fetch () {
  29        # $1 = Remote, $2 = Local
  30        curl -nsfL $curl_extra_args "$1" >"$2"
  31}
  32
  33clone_dumb_http () {
  34        # $1 - remote, $2 - local
  35        cd "$2" &&
  36        clone_tmp="$GIT_DIR/clone-tmp" &&
  37        mkdir -p "$clone_tmp" || exit 1
  38        if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
  39                "`git-repo-config --bool http.noEPSV`" = true ]; then
  40                curl_extra_args="${curl_extra_args} --disable-epsv"
  41        fi
  42        http_fetch "$1/info/refs" "$clone_tmp/refs" ||
  43                die "Cannot get remote repository information.
  44Perhaps git-update-server-info needs to be run there?"
  45        while read sha1 refname
  46        do
  47                name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
  48                case "$name" in
  49                *^*)    continue;;
  50                esac
  51                case "$bare,$name" in
  52                yes,* | ,heads/* | ,tags/*) ;;
  53                *)      continue ;;
  54                esac
  55                if test -n "$use_separate_remote" &&
  56                   branch_name=`expr "z$name" : 'zheads/\(.*\)'`
  57                then
  58                        tname="remotes/$origin/$branch_name"
  59                else
  60                        tname=$name
  61                fi
  62                git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
  63        done <"$clone_tmp/refs"
  64        rm -fr "$clone_tmp"
  65        http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
  66        rm -f "$GIT_DIR/REMOTE_HEAD"
  67}
  68
  69# Read git-fetch-pack -k output and store the remote branches.
  70copy_refs='
  71use File::Path qw(mkpath);
  72use File::Basename qw(dirname);
  73my $git_dir = $ARGV[0];
  74my $use_separate_remote = $ARGV[1];
  75my $origin = $ARGV[2];
  76
  77my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
  78my $tag_top = "tags";
  79
  80sub store {
  81        my ($sha1, $name, $top) = @_;
  82        $name = "$git_dir/refs/$top/$name";
  83        mkpath(dirname($name));
  84        open O, ">", "$name";
  85        print O "$sha1\n";
  86        close O;
  87}
  88
  89open FH, "<", "$git_dir/CLONE_HEAD";
  90while (<FH>) {
  91        my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
  92        next if ($name =~ /\^\173/);
  93        if ($name eq "HEAD") {
  94                open O, ">", "$git_dir/REMOTE_HEAD";
  95                print O "$sha1\n";
  96                close O;
  97                next;
  98        }
  99        if ($name =~ s/^refs\/heads\///) {
 100                store($sha1, $name, $branch_top);
 101                next;
 102        }
 103        if ($name =~ s/^refs\/tags\///) {
 104                store($sha1, $name, $tag_top);
 105                next;
 106        }
 107}
 108close FH;
 109'
 110
 111quiet=
 112local=no
 113use_local=no
 114local_shared=no
 115unset template
 116no_checkout=
 117upload_pack=
 118bare=
 119reference=
 120origin=
 121origin_override=
 122use_separate_remote=t
 123while
 124        case "$#,$1" in
 125        0,*) break ;;
 126        *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
 127        *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
 128          no_checkout=yes ;;
 129        *,--na|*,--nak|*,--nake|*,--naked|\
 130        *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
 131        *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
 132        *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared) 
 133          local_shared=yes; use_local=yes ;;
 134        1,--template) usage ;;
 135        *,--template)
 136                shift; template="--template=$1" ;;
 137        *,--template=*)
 138          template="$1" ;;
 139        *,-q|*,--quiet) quiet=-q ;;
 140        *,--use-separate-remote) ;;
 141        *,--no-separate-remote)
 142                die "clones are always made with separate-remote layout" ;;
 143        1,--reference) usage ;;
 144        *,--reference)
 145                shift; reference="$1" ;;
 146        *,--reference=*)
 147                reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
 148        *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
 149                case "$2" in
 150                '')
 151                    usage ;;
 152                */*)
 153                    die "'$2' is not suitable for an origin name"
 154                esac
 155                git-check-ref-format "heads/$2" ||
 156                    die "'$2' is not suitable for a branch name"
 157                test -z "$origin_override" ||
 158                    die "Do not give more than one --origin options."
 159                origin_override=yes
 160                origin="$2"; shift
 161                ;;
 162        1,-u|1,--upload-pack) usage ;;
 163        *,-u|*,--upload-pack)
 164                shift
 165                upload_pack="--exec=$1" ;;
 166        *,-*) usage ;;
 167        *) break ;;
 168        esac
 169do
 170        shift
 171done
 172
 173repo="$1"
 174test -n "$repo" ||
 175    die 'you must specify a repository to clone.'
 176
 177# --bare implies --no-checkout and --no-separate-remote
 178if test yes = "$bare"
 179then
 180        if test yes = "$origin_override"
 181        then
 182                die '--bare and --origin $origin options are incompatible.'
 183        fi
 184        no_checkout=yes
 185        use_separate_remote=
 186fi
 187
 188if test -z "$origin"
 189then
 190        origin=origin
 191fi
 192
 193# Turn the source into an absolute path if
 194# it is local
 195if base=$(get_repo_base "$repo"); then
 196        repo="$base"
 197        local=yes
 198fi
 199
 200dir="$2"
 201# Try using "humanish" part of source repo if user didn't specify one
 202[ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 203[ -e "$dir" ] && die "destination directory '$dir' already exists."
 204mkdir -p "$dir" &&
 205D=$(cd "$dir" && pwd) &&
 206trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
 207case "$bare" in
 208yes)
 209        GIT_DIR="$D" ;;
 210*)
 211        GIT_DIR="$D/.git" ;;
 212esac && export GIT_DIR && git-init-db ${template+"$template"} || usage
 213
 214if test -n "$reference"
 215then
 216        if test -d "$reference"
 217        then
 218                if test -d "$reference/.git/objects"
 219                then
 220                        reference="$reference/.git"
 221                fi
 222                reference=$(cd "$reference" && pwd)
 223                echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
 224                (cd "$reference" && tar cf - refs) |
 225                (cd "$GIT_DIR/refs" &&
 226                 mkdir reference-tmp &&
 227                 cd reference-tmp &&
 228                 tar xf -)
 229        else
 230                die "reference repository '$reference' is not a local directory."
 231        fi
 232fi
 233
 234rm -f "$GIT_DIR/CLONE_HEAD"
 235
 236# We do local magic only when the user tells us to.
 237case "$local,$use_local" in
 238yes,yes)
 239        ( cd "$repo/objects" ) ||
 240                die "-l flag seen but repository '$repo' is not local."
 241
 242        case "$local_shared" in
 243        no)
 244            # See if we can hardlink and drop "l" if not.
 245            sample_file=$(cd "$repo" && \
 246                          find objects -type f -print | sed -e 1q)
 247
 248            # objects directory should not be empty since we are cloning!
 249            test -f "$repo/$sample_file" || exit
 250
 251            l=
 252            if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
 253            then
 254                    l=l
 255            fi &&
 256            rm -f "$GIT_DIR/objects/sample" &&
 257            cd "$repo" &&
 258            find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
 259            ;;
 260        yes)
 261            mkdir -p "$GIT_DIR/objects/info"
 262            echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
 263            ;;
 264        esac
 265        git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 266        ;;
 267*)
 268        case "$repo" in
 269        rsync://*)
 270                rsync $quiet -av --ignore-existing  \
 271                        --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
 272                exit
 273                # Look at objects/info/alternates for rsync -- http will
 274                # support it natively and git native ones will do it on the
 275                # remote end.  Not having that file is not a crime.
 276                rsync -q "$repo/objects/info/alternates" \
 277                        "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 278                        rm -f "$GIT_DIR/TMP_ALT"
 279                if test -f "$GIT_DIR/TMP_ALT"
 280                then
 281                    ( cd "$D" &&
 282                      . git-parse-remote &&
 283                      resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
 284                    while read alt
 285                    do
 286                        case "$alt" in 'bad alternate: '*) die "$alt";; esac
 287                        case "$quiet" in
 288                        '')     echo >&2 "Getting alternate: $alt" ;;
 289                        esac
 290                        rsync $quiet -av --ignore-existing  \
 291                            --exclude info "$alt" "$GIT_DIR/objects" || exit
 292                    done
 293                    rm -f "$GIT_DIR/TMP_ALT"
 294                fi
 295                git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
 296                ;;
 297        https://*|http://*|ftp://*)
 298                if test -z "@@NO_CURL@@"
 299                then
 300                        clone_dumb_http "$repo" "$D"
 301                else
 302                        die "http transport not supported, rebuild Git with curl support"
 303                fi
 304                ;;
 305        *)
 306                case "$upload_pack" in
 307                '') git-fetch-pack --all -k $quiet "$repo" ;;
 308                *) git-fetch-pack --all -k $quiet "$upload_pack" "$repo" ;;
 309                esac >"$GIT_DIR/CLONE_HEAD" ||
 310                        die "fetch-pack from '$repo' failed."
 311                ;;
 312        esac
 313        ;;
 314esac
 315test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
 316
 317if test -f "$GIT_DIR/CLONE_HEAD"
 318then
 319        # Read git-fetch-pack -k output and store the remote branches.
 320        @@PERL@@ -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin" ||
 321        exit
 322fi
 323
 324cd "$D" || exit
 325
 326if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
 327then
 328        # a non-bare repository is always in separate-remote layout
 329        remote_top="refs/remotes/$origin"
 330        head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
 331        case "$head_sha1" in
 332        'ref: refs/'*)
 333                # Uh-oh, the remote told us (http transport done against
 334                # new style repository with a symref HEAD).
 335                # Ideally we should skip the guesswork but for now
 336                # opt for minimum change.
 337                head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
 338                head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
 339                ;;
 340        esac
 341
 342        # The name under $remote_top the remote HEAD seems to point at.
 343        head_points_at=$(
 344                (
 345                        echo "master"
 346                        cd "$GIT_DIR/$remote_top" &&
 347                        find . -type f -print | sed -e 's/^\.\///'
 348                ) | (
 349                done=f
 350                while read name
 351                do
 352                        test t = $done && continue
 353                        branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
 354                        if test "$head_sha1" = "$branch_tip"
 355                        then
 356                                echo "$name"
 357                                done=t
 358                        fi
 359                done
 360                )
 361        )
 362
 363        # Write out remote.$origin config, and update our "$head_points_at".
 364        case "$head_points_at" in
 365        ?*)
 366                # Local default branch
 367                git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
 368
 369                # Tracking branch for the primary branch at the remote.
 370                origin_track="$remote_top/$head_points_at" &&
 371                git-update-ref HEAD "$head_sha1" &&
 372
 373                # Upstream URL
 374                git-repo-config remote."$origin".url "$repo" &&
 375
 376                # Set up the mappings to track the remote branches.
 377                git-repo-config remote."$origin".fetch \
 378                        "refs/heads/*:$remote_top/*" '^$' &&
 379                rm -f "refs/remotes/$origin/HEAD"
 380                git-symbolic-ref "refs/remotes/$origin/HEAD" \
 381                        "refs/remotes/$origin/$head_points_at" &&
 382
 383                git-repo-config branch."$head_points_at".remote "$origin" &&
 384                git-repo-config branch."$head_points_at".merge "refs/heads/$head_points_at"
 385        esac
 386
 387        case "$no_checkout" in
 388        '')
 389                test "z$quiet" = z && v=-v || v=
 390                git-read-tree -m -u $v HEAD HEAD
 391        esac
 392fi
 393rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
 394
 395trap - 0
 396